#!/bin/bash
function pause {
	read -n1 -rsp $'Press any key to continue...\n'
}
function config_git {
	echo -n "Enter your name (git):"
	read name
	echo -n "Enter your email address (git):"
	read mail
	git config --global user.name "$name"
	git config --global user.email $mail
	git config --global gpg.program gpg2
	git config --global commit.gpgsign true
    	git config --global help.autocorrect 50
	git config --list
}
function install_software {
					#Negativo17 Repo
	sudo dnf config-manager --add-repo=http://negativo17.org/repos/fedora-multimedia.repo
					#Google Play Music Desktop Player
	export rpm_links=$(curl -s https://api.github.com/repos/MarshallOfSound/Google-Play-Music-Desktop-Player-UNOFFICIAL-/releases | grep browser_download_url | grep '64[.]rpm' | head -n 1 | cut -d '"' -f 4)
					#RPM Fusion Free
	export rpm_links="$rpm_links	http://download1.rpmfusion.org/free/fedora/rpmfusion-free-release-$(rpm -E %fedora).noarch.rpm"
					#RPM Fusion Non-Free
	export rpm_links="$rpm_links 	http://download1.rpmfusion.org/nonfree/fedora/rpmfusion-nonfree-release-$(rpm -E %fedora).noarch.rpm"
					#Keybase
	export rpm_links="$rpm_links 	https://prerelease.keybase.io/keybase_amd64.rpm"
	sudo dnf install -y $rpm_links
	sudo dnf copr enable -y decathorpe/syncthing							#Syncthing
	sudo dnf copr enable -y tpokorra/nextcloud								#Nextcloud-Client
	export packages="vlc ffmpeg"											#Multimedia Stuff
	export packages="$packages hexchat gajim"								#Messaging
	export packages="$packages nextcloud-client"							#Nextcloud
	export packages="$packages menulibre shutter deluge syncthing* yubi*"	#GUI Tools
	export packages="$packages htop vim pass heimdall"						#Command Line Tools
	export packages="$packages gimp digikam"								#Photography
	export packages="$packages gnome-tweak-tool"							#Gnome
	export packages="$packages xournal"										#Stylusstuff
	export packages="$packages latexila texlive-scheme-full"				#LaTeX
	export packages="$packages java-1.8.0-openjdk-devel golang"				#SDKs
																			#Android SDK Dependencies
	export packages="$packages compat-libstdc++-296.i686 compat-libstdc++-33.i686 compat-libstdc++-33.x86_64 ncurses-libs.i686"
	sudo dnf install -y $packages --best --allowerasing
	sudo dnf upgrade -y
    git clone https://github.com/vibou/vibou.gTile.git ~/.local/share/gnome-shell/extensions/gTile@vibou
}
function config_ssh {
	echo -n "Application Name (ssh key):"
	read application
	echo -n "Hostname (ssh key):"
	read hostname
	DATE=`date +%Y%m%d`
	comment="$DATE - $application - $hostname"
	ssh-keygen -b 8192 -t rsa -C "$comment" -f ~/.ssh/id_rsa
	cat ~/.ssh/id_rsa.pub
	echo "Insert this SSH key into gogs before you continue."
	pause
}
function get_gpg_keys {
	gpg2 --keyserver hkp://pool.sks-keyservers.net --recv-keys 691C036821A1C2A05415F572F338AD3815B5D61C 33BD6633839B232E1A24BF4262BEE5EB8F370DC6
	gpg2 --import ~/.password-store/.keybase-key.pgp
    sudo systemctl enable pcscd && sudo systemctl start pcscd
}
function clone_git_repos {
	cd ~
	git clone ssh://git@jcg.re:10022/jcgruenhage/.password-store.git
	mkdir dev
	cd dev
	git clone ssh://git@jcg.re:10022/jcgruenhage/scripts.git
	git clone ssh://git@jcg.re:10022/jcgruenhage/prog16_17.git
	git clone ssh://git@jcg.re:10022/jcgruenhage/homepage.git
	git clone ssh://git@jcg.re:10022/klug-O-soft/kOs_Timer.git
}

install_software
config_ssh
config_git
clone_git_repos
get_gpg_keys





